package com.denizenscript.clientizen.events;

import com.denizenscript.denizencore.events.ScriptEvent;
import com.denizenscript.denizencore.objects.ObjectTag;
import com.denizenscript.denizencore.objects.core.ElementTag;
import java.util.HashMap;
import java.util.Map;
import net.minecraft.class_429;
import net.minecraft.class_433;
import net.minecraft.class_437;
import net.minecraft.class_457;
import net.minecraft.class_481;
import net.minecraft.class_490;

public class ScreenOpenCloseEvent extends ScriptEvent {

    public static ScreenOpenCloseEvent instance;

    public static Map<String, Class<?>> TYPE_MAP = new HashMap<>();

    static {
        TYPE_MAP.put("inventory", class_490.class);
        TYPE_MAP.put("creative", class_481.class);
        TYPE_MAP.put("pause", class_433.class);
        TYPE_MAP.put("options", class_429.class);
        TYPE_MAP.put("advancements", class_457.class);
    }

    public String type;
    public boolean opened;
    public boolean switched;

    public ScreenOpenCloseEvent() {
        registerCouldMatcher("<'type'> screen opened|closed");
        instance = this;
    }

    @Override
    public boolean matches(ScriptPath path) {
        String screenMatcher = path.eventArgLowerAt(0);
        if (!runGenericCheck(screenMatcher, type)) {
            return false;
        }
        if (opened != path.eventArgLowerAt(2).equals("opened")) {
            return false;
        }
        return super.matches(path);
    }

    @Override
    public ObjectTag getContext(String name) {
        switch (name) {
            case "screen_type": return new ElementTag(type);
            case "switched": return new ElementTag(switched);
        }
        return super.getContext(name);
    }


    public void handleScreenChange(class_437 screen, class_437 otherScreen, boolean open) {
        for (Map.Entry<String, Class<?>> pair : TYPE_MAP.entrySet()) {
            if (pair.getKey().equals("inventory") && screen instanceof class_481) {
                continue;
            }
            if (pair.getValue().isInstance(screen)) {
                type = pair.getKey();
                opened = open;
                switched = otherScreen != null;
                fire();
                return;
            }
        }
    }
}
